<template>
  <div>
    <div class="container">
      <div class="level">
        <div class="level-left">
          <p class="1">
            You are logged in as {{ user }}
          </p>
        </div>
        <!-- <div class="level-right">
          <b-button
            icon-left="logout-variant"
          >
            Log Out
          </b-button>
          <a
            :href="logOutUrl"
          > <b-icon icon="logout-variant" />Log Out</a>
        </div> -->
      </div>
    </div>
    <section class="section has-background-zerow-green">
      <div
        class="container"
        style="min-height:75vh;"
      >
        <div class="columns">
          <div class="column is-four-fifths">
            <h1 class="is-size-2 title has-text-zerow-green-dark">
              Farmer
            </h1>
          </div>
          <div class="column">
            <div
              class="image is-128x128"
            >
              <img
                :src="
                  farmer"
                class="is-rounded filter-white"
              >
            </div>
          </div>
        </div>
        <div class="box">
          <h1 class="is-size-4 title has-text-zerow-green-dark">
            Available Fruits
          </h1>
          <div class="block">
            <b-table
              :data="foodData"
            >
              <b-table-column
                v-slot="props"
                field="fruit.name"
                label="Name"
              >
                {{ props.row.fruit.name }}
              </b-table-column>
              <b-table-column
                v-slot="props"
                field="fruit.quantity"
                label="Quantity"
              >
                {{ props.row.fruit.quantity }}
              </b-table-column>
              <b-table-column
                v-slot="props"
                field="fruit.expiry_date"
                label="Expiry Date"
              >
                {{ props.row.fruit.expiry_date }}
              </b-table-column>
              <b-table-column
                v-slot="props"
                field="state"
                label="State"
              >
                {{ props.row.state }}
                <!-- <span>
              <b-icon
                :icon="props.row.offered ? 'check-bold': 'cancel'"
              />
            </span> -->
              </b-table-column>
              <b-table-column
                v-slot="props"
              >
                <span>
                  <b-button
                    v-if="!props.row.offered"
                    class="button is-success"
                    @click="offerFruit(props.row)"
                  >Offer Fruit</b-button>
                </span>
              </b-table-column>

              <template #empty>
                <div class="has-text-centered">
                  No records
                </div>
              </template>
            </b-table>
          </div>
          <div class="block">
            <card-component
              class="has-text-zerow-green-dark"
              title="Add fruits to the available fruits."
            >
              <form>
                <div class="columns">
                  <div class="column">
                    <b-field
                      horizontal
                      label="Name"
                    >
                      <b-input
                        v-model="fruitObj.fruit.name"
                        placeholder="Name"
                        required
                      />
                    </b-field>
                    <b-field
                      horizontal
                      label="Expiry Date"
                    >
                      <b-input
                        v-model="fruitObj.fruit.expiry_date"
                        placeholder="2023-01-01"
                      />
                    </b-field>
                  </div>
                  <div class="column">
                    <b-field
                      horizontal
                      label="Quantity"
                    >
                      <b-input
                        v-model.number="fruitObj.fruit.quantity"
                        placeholder="Quantity"
                        type="number"
                      />
                    </b-field>
                  </div>
                </div>
                <footer>
                  <b-button
                    class="button is-success"
                    :disabled="isDisabled"
                    @click="addFood"
                  >
                    Send
                  </b-button>
                </footer>
              </form>
            </card-component>
          </div>
        </div>
        <div class="box">
          <h1 class="is-size-4 title has-text-zerow-green-dark">
            Fruit Requests from Mobile Press
          </h1>
          <div class="block">
            <b-table
              :data="fruitRequests"
            >
              <b-table-column
                v-slot="props"
                field="fruit.name"
                label="Name"
              >
                <div class="has-text-zerow-green-dark">
                  {{ props.row.fruit_request.fruits[0].name }}
                </div>
              </b-table-column>
              <b-table-column
                v-slot="props"
                field="fruit.quantity"
                label="Quantity"
              >
                {{ props.row.fruit_request.fruits[0].quantity }}
              </b-table-column>
              <b-table-column
                v-slot="props"
                field="state"
                label="State"
              >
                {{ props.row.state }}
                <!-- <span>
              <b-icon
                :icon="props.row.offered ? 'check-bold': 'cancel'"
              />
            </span> -->
              </b-table-column>
              <b-table-column
                v-slot="props"
              >
                <span>
                  <b-button
                    v-if="(props.row.state === 'REQUESTED')"
                    class="button is-success"
                    @click="acceptFruitRequest(props.row.fruit_request.id)"
                  >Accept</b-button>
                </span>
                <span>
                  <b-button
                    v-if="(props.row.state === 'REQUESTED')"
                    class="button is-danger"
                    @click="rejectFruitRequest(props.row.fruit_request.id)"
                  >Reject</b-button>
                </span>
              </b-table-column>
              <template #empty>
                <div class="has-text-centered has-text-zerow-green-dark">
                  No records
                </div>
              </template>
            </b-table>
          </div>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import { defineComponent } from '@vue/composition-api'
import axios from 'axios'
import CardComponent from '@/components/CardComponent.vue'
import farmer from '@/assets/farmer.svg'
import { v4 as uuidv4 } from 'uuid'

export default defineComponent({
  name: 'Home',
  components: {
    CardComponent
  },
  data () {
    return {
      api: axios.create({
        baseURL: 'api/',
        timeout: 5000
      }),
      farmer: farmer,
      foodData: [],
      fruitOfferings: [],
      fruitRequests: [],
      fruitObj: {
        id: '',
        fruit: {
          name: '',
          quantity: 0,
          price: 0.0,
          expiry_date: ''
        }

      },
      uuidv4: uuidv4,
      user: '',
      logOutUrl: '',
      titleStack: ['Admin', 'ZeroW']
    }
  },
  computed: {
    isDisabled () {
      return !this.fruitObj.fruit.name || !this.fruitObj.fruit.expiry_date
    }
  },
  created: async function () {
    await this.getUser()
    await this.fetchFood()
    await this.fetchFruitRequests()
  },
  methods: {
    getUser: async function () {
      const resp = await this.api.get('/press/user/')
      this.user = resp.data.user
      this.logOutUrl = resp.data.logOutUrl
    },
    fetchFood: async function () {
      const food = await this.api.get('/farmer/fruits/')
      const fruitOfferings = await this.fetchFruitOfferings()
      food.data.forEach(obj => {
        obj.offered = fruitOfferings.map(x => x.id).includes(obj.id)
        obj.state = fruitOfferings.find(x => x.id === obj.id)?.state
      })
      this.foodData = food.data
    },
    fetchFruitOfferings: async function () {
      const resp = await this.api.get('/farmer/fruitOfferings/')
      return resp.data
    },
    fetchFruitRequests: async function () {
      const resp = await this.api.get('/farmer/fruitRequests/')
      this.fruitRequests = resp.data
    },
    offerFruit: async function (fruit) {
      const resp = await this.api.post('/farmer/fruitOfferings/',
        {
          offer_id: fruit.id,
          fruits: [
            fruit.fruit
          ]
        }, {
          headers: {
            'content-type': 'application/json'
          }
        }

      )
      if (resp.status === 200) {
        await this.fetchFood()
      }
    },
    addFood: async function () {
      this.fruitObj.id = this.uuidv4()
      console.log(this.fruitObj)
      const resp = await this.api.post('/farmer/fruits/',
        [this.fruitObj], {
          headers: {
            'content-type': 'application/json'
          }
        }
      )
      if (resp.status === 200) {
        await this.fetchFood()
      }
    },
    acceptFruitRequest: async function (requestId) {
      const resp = await this.api.post('/farmer/acceptFruitRequest/', requestId, {
        headers: {
          'content-type': 'application/json'
        }
      })
      if (resp.status === 200) {
        await this.fetchFruitRequests()
      }
    },
    rejectFruitRequest: async function (requestId) {
      const resp = await this.api.post('/farmer/rejectFruitRequest/', requestId, {
        headers: {
          'content-type': 'application/json'
        }
      })
      if (resp.status === 200) {
        await this.fetchFruitRequests()
      }
    }
  }
})
</script>
